module VueCK
    class Element    
        def initialize(doc, type)
            @node = doc.css(ELEMENTS[type])
            @type = type
            verify
        end

        def verify
            return unless REQUIRED[@type]
            raise ComonentRenderError if @node.empty?
        end

        def lang
            lang_attribute = @node.attribute(ATTRIBUTES[:lang]).first
            return LANG_DEFALTS[@type] unless lang_attribute
            lang_attribute.value
        end

        def empty?
            @node.empty?
        end

        def text
            @node.first.children.text
        end

        def render
            return text if lang == LANG_DEFALTS[@type]
            raise InvalidTemplateEngine unless Tilt[lang]
            Tilt[lang].new { text }.render
        end
    end
end